
using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using System.Linq;
using MeshVR;
using SimpleJSON;
using GPUTools.Common.Scripts.PL.Tools;
using GPUTools.Skinner.Scripts.Providers;
/// <summary>
/// MaleBodySmootherTesselletion by Hunting-Succubus
///Based on Body Shader 1.0.0, by Acid Bubbles
/// </summary>
public class GhostPenetrator : MVRScript
{
    private const string DefaultShaderKey = "Keep default";

    public static readonly Dictionary<string, string[]> GroupedMaterials = new Dictionary<string, string[]>
    {
		
		{
            "Tess",
             new[]
            {
                "defaultMat",
                "Anus",
				"Anus",
                "Ears",
                "Face",
                "Feet",
                "Forearms",
				"Genitalia",
				"Genitalia-1",
                "Hands",
                "Head",
                "Hips",
                "Legs",
                "Neck",
                "Nipples",
                "Nostrils",
                "Lips",
                "Shoulders",
                "Torso",
				"Torso-1",
				"Torso-2",
				"Genitals",
				"Hips-1",
			
				"Hidden",
				"Anus",
				"Anus-1",
				"Genital",
				"Anus-1",
                "Ears-1",
                "Face-1",
                "Feet-1",
                "Forearms-1",
                "Hands-1",
                "Head-1",
                "Hips-1",
                "Legs-1",
                "Neck-1",
                "Nipples-1",
                "Nostrils-1",
                "Lips-1",
                "Shoulders-1",
                "Torso-1",


				"Hidden-1",
				"Genital-1",
				"Anus-2",
                "Ears-2",
                "Face-2",
                "Feet-2",
                "Forearms-2",
                "Hands-2",
                "Head-2",
                "Hips-3",
                "Legs-2",
                "Neck-2",
                "Nipples-2",
                "Nostrils-2",
                "Lips-2",
                "Shoulders-2",
                "Torso-2",

				"Hips-2",
				"Hidden-2"

				
            }
		},
        };
    private Atom _person;
    private DAZCharacterSelector _selector;
    private bool _dirty;
    private DAZCharacter _character;
    private Dictionary<Material, Shader> _original;
    private List<MapSettings> _map = new List<MapSettings>();
    private DAZHairGroup _hair;
    private JSONStorableStringChooser _applyToJSON;
    private JSONStorableStringChooser _shaderJSON;
    private JSONStorableFloat _alphaJSON;
    private JSONStorableFloat _renderQueue;
	private JSONStorableFloat gloss;
	private JSONStorableFloat alpha;
	JSONStorableBool renderOriginal;
	JSONStorableBool renderFace;	
	JSONStorableBool renderGenitila;
	JSONStorableBool renderRightHand;
	JSONStorableBool renderLeftHand;
	DAZClothingItem item1;
	DAZClothingItem item1a;
	DAZClothingItem item2;
	DAZClothingItem item2a;
	DAZClothingItem item3;
	DAZClothingItem item3a;
	DAZClothingItem item4;
	DAZClothingItem item4a;

    private class MapSettings
    {
        public string ShaderName { get; set; }
        public string MaterialName { get; set; }
        public float Alpha { get; set; }
        public int RenderQueue { get; set; }
    }

    public override void Init()
    {
        try
        {
            if (containingAtom?.type != "Person")
            {
                SuperController.LogError($"This plugin only works on Person atoms");
                DestroyImmediate(this);
                return;
            }
			
            _person = containingAtom;
            _selector = _person.GetComponentInChildren<DAZCharacterSelector>();
			/////////////////////////////////////////////////////////////////////
			
				JSONStorable geometry = containingAtom.GetStorableByID("geometry");
				DAZCharacterSelector dcs = geometry as DAZCharacterSelector;
				

			renderFace = new JSONStorableBool("Face", true);	
			RegisterBool(renderFace);
            //CreateToggle(renderFace, false);
			
			renderGenitila = new JSONStorableBool("Genitila", true);	
			RegisterBool(renderGenitila);
            //CreateToggle(renderGenitila, false);
			
			renderRightHand = new JSONStorableBool("Right Hand", true);	
			RegisterBool(renderRightHand);
            //CreateToggle(renderRightHand, false);
			
			renderLeftHand = new JSONStorableBool("Lef tHand", true);	
			RegisterBool(renderLeftHand);
            //CreateToggle(renderLeftHand, false);

			item1 = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Face Dummy 1");
			item1a = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Face Dummy 2");
			item2 = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Genital Dummy 1");
			item2a = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Genital Dummy 2");
			item3 = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Right Hand Dummy 1");
			item3a = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Right Hand Dummy 2");
			item4 = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Left Hand Dummy 1");
			item4a = _selector
					.clothingItems
					.First(h => h.displayName == "Ghost Left Hand Dummy 2");						
			
			gloss = new JSONStorableFloat("Gloss", 8.0f, 2.0f, 8.0f, true, true);
			RegisterFloat(gloss);
			//CreateSlider(gloss, false);  
			
			alpha = new JSONStorableFloat("Opacity", -0.8f, -1.0f, 1.0f, true, true);
			RegisterFloat(alpha);
			//CreateSlider(alpha, false);  
			
			//CreateButton("Apply").button.onClick.AddListener(() => {
                   //Reapply();
				   //UpdateMat();
                   // });    
			
			
			


            _dirty = true;
        }
        catch (Exception e)
        {
            SuperController.LogError("Failed to init: " + e);
            DestroyImmediate(this);
        }
    }
void Reapply(){
		if(renderFace.val==true){
		_selector.SetActiveClothingItem(item1, true);
		_selector.SetActiveClothingItem(item1a, true);}		
	else{
		_selector.SetActiveClothingItem(item1, false);
		_selector.SetActiveClothingItem(item1a, false);}		
	
		if(renderGenitila.val==true){
		_selector.SetActiveClothingItem(item2, true);
		_selector.SetActiveClothingItem(item2a, true);}		
	else{
		_selector.SetActiveClothingItem(item2, false);
		_selector.SetActiveClothingItem(item2a, false);}	
	
		if(renderRightHand.val==true){
		_selector.SetActiveClothingItem(item3, true);
		_selector.SetActiveClothingItem(item3a, true);}		
	else{
		_selector.SetActiveClothingItem(item3, false);
		_selector.SetActiveClothingItem(item3a, false);}	
	
		if(renderLeftHand.val==true){
		_selector.SetActiveClothingItem(item4, true);
		_selector.SetActiveClothingItem(item4a, true);}		
	else{
		_selector.SetActiveClothingItem(item4, false);
		_selector.SetActiveClothingItem(item4a, false);}	
}

		void UpdateMat() {
						var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
				        foreach (var wrap in allWraps) 
						{
								//SuperController.LogMessage("WRAPCLOTH="+wrap.ToString());
								if (wrap.ToString().Contains("Hunting-Succubus:Ghost")&&wrap.ToString().Contains("Dummy2")) 
										{
										//SuperController.LogMessage("Clothes Loaded="+wrap.ToString());	
											foreach (var mat in wrap.GPUmaterials) 
											{
											//SuperController.LogMessage("GPUmat name="+mat.name+", _AlphaAdjust="+mat.GetFloat("_AlphaAdjust"));
											mat.SetFloat("_Shininess", gloss.val);
											}
										}
								if (wrap.ToString().Contains("Hunting-Succubus:Ghost")&&wrap.ToString().Contains("Dummy1")) 
										{
										//SuperController.LogMessage("Clothes Loaded="+wrap.ToString());	
											foreach (var mat in wrap.GPUmaterials) 
											{
											//SuperController.LogMessage("GPUmat name="+mat.name+", _AlphaAdjust="+mat.GetFloat("_AlphaAdjust"));
											mat.SetFloat("_AlphaAdjust", alpha.val);
											}
										}		
						}
		}

    private static List<string> ScanShaders()
    {
        return UnityEngine.Resources
            .FindObjectsOfTypeAll(typeof(Shader))
            .Cast<Shader>()
            .Where(s => s != null)
            .Select(s => s.name)
            .Where(s => !string.IsNullOrEmpty(s) && !s.StartsWith("__"))
            .OrderBy(s => s)
            .ToList();
    }

    private void ApplyToGroup()
    {
        var group = _applyToJSON.val;
        string[] materialNames;
        if (!GroupedMaterials.TryGetValue(group, out materialNames))
            return;

        foreach (var materialName in materialNames)
        {
            var setting = _map.FirstOrDefault(m => m.MaterialName == materialName);
            if (setting == null) continue;
			setting.ShaderName = _shaderJSON.val;
            setting.ShaderName = "Sprites/Mask";
            setting.Alpha = _alphaJSON.val;
            setting.RenderQueue = (int)Math.Round(_renderQueue.val);
        }

        _dirty = true;
    }
	
	    private void ApplyToGroupTess()
    {
        var group = "Glass";
        string[] materialNames;
        if (!GroupedMaterials.TryGetValue(group, out materialNames))
            return;

        foreach (var materialName in materialNames)
        {
            var setting = _map.FirstOrDefault(m => m.MaterialName == materialName);
            if (setting == null) continue;
            setting.ShaderName = _shaderJSON.val;
            setting.Alpha = _alphaJSON.val;
            setting.RenderQueue = (int)Math.Round(_renderQueue.val);
        }

        _dirty = true;
    }

    public void Update()
    {
        try
        {
            if (!_dirty)
            {
                if (_selector.selectedCharacter != _character)
                    _dirty = true;
                    _dirty = true;

                return;
            }

            _character = _selector.selectedCharacter;
            if (_character == null) return;
            var skin = _character.skin;

            if (skin == null) return;

            if (_original == null)
            {
                _original = new Dictionary<Material, Shader>();
                foreach (var mat in skin.GPUmaterials)
                {
                    _original.Add(mat, mat.shader);
                }
            }

            foreach (var setting in _map)
            {
                if (setting.ShaderName == DefaultShaderKey || setting.ShaderName == null) ;
			var shader = Shader.Find("Custom/Subsurface/GlossNMTessMappedFixedComputeBuff");

                if (shader == null) return;
                var mat = skin.GPUmaterials.FirstOrDefault(x => x.name == setting.MaterialName);
                if (mat == null) continue;
            }
						        Material[] mats = skin.GPUmaterials;
        foreach (Material mat in mats) {
            if (mat.name == "Genitalia" || mat.name == "Genitalia-1") 
			{
				continue;
            }
			    mat.shader = Shader.Find("Custom/Subsurface/TransparentGlossNoCullSeparateAlphaComputeBuff");
                mat.SetFloat("_AlphaAdjust", -1f);
                mat.renderQueue = 5000;
        }


            skin.BroadcastMessage("OnApplicationFocus", true);
            _dirty = false;
			
			//UpdateMat();
            //Reapply();
        }
        catch (Exception e)
        {
            SuperController.LogError("something failed: " + e);
        }

    }

    public void OnDisable()
    {
        try
        {
            _dirty = false;
            if (_original != null)
            {
                foreach (var x in _original)
                    x.Key.shader = x.Value;
            }
            _character?.skin?.BroadcastMessage("OnApplicationFocus", true);
					
        }
        catch (Exception e)
        {
           // SuperController.LogError("something failed: " + e);
        }
    }

    public void OnDestroy()
    {
        OnDisable();
    }
}

